import es
import playerlib
import cmdlib
import popuplib
import keyvalues
import soccer.soccer as soccerlib
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Team Skins Script"
info.version = soccerlib.info.version
info.basename = "soccerteamskins"
info.author = "chrismrulz"

tskin = soccerlib.config["Skins"]["tskin"]
ctskin = soccerlib.config["Skins"]["ctskin"]
tskinname = soccerlib.config["Skins"]["tskin"]
ctskinname = soccerlib.config["Skins"]["ctskin"]
skins = soccerlib.config["Skins"]
awayskins = soccerlib.config["Away Skins"]

teamselect = 0

def loadblock():
	if(es.exists('saycommand', '!skin') != 1):
		cmdlib.registerSayCommand('!skin', skinsmenu, 'Shows the skin menu', 'use_ref', 'ADMIN')
	if(es.exists('clientcommand', 'skin') != 1):
		cmdlib.registerClientCommand('skin', skinsmenu, 'Shows the skin menu', 'use_ref', 'ADMIN')
	for tagname in skins:
		if(tagname != 'awaychar'):
			es.stringtable('downloadables', skins[tagname])
	es.msg("#Green", "Soccer Team Skins Script On - by Gideon / Toph")

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('skin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isIdAuthorized(x, 'skin')
    else:
        isAuthed = lambda x: False

def load():
	setup_auth()
	loadblock()

def es_map_start(event_var):
	loadblock()

def unload():
	cmdlib.unregisterClientCommand('skin')
	cmdlib.unregisterSayCommand('!skin')
	es.msg("#Green", "Soccer Team Skins Script Off")

def skinsmenu(userid, args):
	skPopup = popuplib.easymenu('Team Skins Menu', None, sk_option)
	skPopup.addoption('ctselect', 'Select CT skin')
	skPopup.addoption('tselect', 'Select T skin')
	skPopup.addoption('skinsremove', 'Remove team skins')
	skPopup.send(userid)

def sk_option(userid, choice, popupname):
	if(choice == 'skinsremove'):
		global teamselect
		teamselect = 0
		tskinname = soccerlib.config["Skins"]["tskin"]
		ctskinname = soccerlib.config["Skins"]["ctskin"]
		for players in playerlib.getPlayerList('#all,!un,!spec'):
			team = players.team
			parseskins(userid, team)
		es.tell(userid, "#green", "Team skins have been removed.")
	else:
		skins_select(userid, choice)

def skins_select(userid, choice):
	global teamselect
	skinsselect = popuplib.easymenu('skinsselect', None, skinschosen)
	skinsselect.settitle('Teams')
	if(choice == 'ctselect'):
		teamselect = 3
	elif(choice == 'tselect'):
		teamselect = 2
	for tagname in skins:
		tagname = unicode(tagname)
		if(tagname != 'ctskin' and tagname != 'tskin'):
			skinsselect.addoption(tagname, tagname)
	skinsselect.send(userid)
				
def skinschosen(userid, choice, popupname):
	global tagname
	tagname = choice
	if(tagname not in awayskins):
		homeskinchosen(userid, tagname)
	elif(skins[tagname] != awayskins[tagname]):
		skinsha = popuplib.easymenu('skinshaselect', None, skinchosen)
		skinsha.settitle('Choose Home or Away Kit')
		skinsha.addoption('home', 'Home')
		skinsha.addoption('away', 'Away')
		skinsha.send(userid)
	else:
		homeskinchosen(userid, tagname)

def homeskinchosen(userid, tagname):
	tagname1 = tagname.encode('utf8')
	if(teamselect == 2):
		global tskinname
		tskinname = skins[tagname]
		es.tell(int(userid), "#multi", "#greenThe #lightgreenT #greenteam has been assigned the #lightgreen%s #greenhome skin."%tagname1)
	elif(teamselect == 3):
		global ctskinname
		ctskinname = skins[tagname]
		es.tell(int(userid), "#multi", "#greenThe #lightgreenCT #greenteam has been assigned the #lightgreen%s #greenhome skin."%tagname1)
	parseskins(userid, teamselect)
	
def awayskinchosen(userid, tagname):
	tagname1 = tagname.encode('utf8')
	if(teamselect == 2):
		global tskinname
		tskinname = awayskins[tagname]
		es.tell(int(userid), "#multi", "#greenThe #lightgreenT #greenteam has been assigned the #lightgreen%s #greenaway skin."%tagname1)
	elif(teamselect == 3):
		global ctskinname
		ctskinname = awayskins[tagname]
		es.tell(int(userid), "#multi", "#greenThe #lightgreenCT #greenteam has been assigned the #lightgreen%s #greenaway skin."%tagname1)
	parseskins(userid, teamselect)

def skinchosen(userid, choice, popupname):
	if(choice == 'home'):
		homeskinchosen(userid, tagname)
	elif(choice == 'away'):
		awayskinchosen(userid, tagname)

def parseskins(userid, team):
	toset = ""
	if(team == 2):
		t_players = playerlib.getPlayerList('#t')
		for players in t_players:
			tgoalie = es.ServerVar('tgoalie')
			if(players.steamid == 'BOT'):
				if(players.userid != tgoalie):
					if(teamselect != 0):
						global tskinname
						toset = tskinname
						playerlib.getPlayer(players.userid).setModel(toset)
					else:
						playerlib.getPlayer(players.userid).setModel(tskin)
			elif(players.steamid != tgoalie):
				if(teamselect != 0):
					global tskinname
					toset = tskinname
					playerlib.getPlayer(players.userid).setModel(toset)
				else:
					playerlib.getPlayer(players.userid).setModel(tskin)
	elif(team == 3):
		ct_players = playerlib.getPlayerList('#ct')
		for players in ct_players:
			ctgoalie = es.ServerVar('ctgoalie')
			if(players.steamid == 'BOT'):
				if(players.userid != ctgoalie):
					if(teamselect != 0):
						global ctskinname
						toset = ctskinname
						playerlib.getPlayer(players.userid).setModel(toset)
					else:
						playerlib.getPlayer(players.userid).setModel(ctskin)
			elif(players.steamid != ctgoalie):
				if(teamselect != 0):
					global ctskinname
					toset = ctskinname
					playerlib.getPlayer(players.userid).setModel(toset)
				else:
					playerlib.getPlayer(players.userid).setModel(ctskin)

def player_spawn(event_var):
	parseskins(int(event_var['userid']), int(event_var['es_userteam']))